/*
 * Copyright (C) 2010 Teleal GmbH, Switzerland
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.teleal.cling.test.data;

import org.teleal.cling.model.meta.Device;
import org.teleal.cling.model.meta.DeviceDetails;
import org.teleal.cling.model.meta.DeviceIdentity;
import org.teleal.cling.model.meta.DeviceService;
import org.teleal.cling.model.meta.Icon;
import org.teleal.cling.model.meta.ManufacturerDetails;
import org.teleal.cling.model.meta.ModelDetails;
import org.teleal.cling.model.meta.Service;
import org.teleal.cling.model.types.DeviceType;
import org.teleal.cling.model.types.ServiceId;
import org.teleal.cling.model.types.ServiceType;
import org.teleal.cling.model.types.UDADeviceType;
import org.teleal.cling.model.types.UDAServiceId;
import org.teleal.cling.model.types.UDAServiceType;
import org.teleal.cling.model.types.UDN;
import org.teleal.common.util.URIUtil;

import java.net.URI;
import java.net.URL;

/**
 * @author Christian Bauer
 */
public class SampleDeviceEmbeddedTwo extends SampleDevice {

    public SampleDeviceEmbeddedTwo(DeviceIdentity identity, Service service, Device[] embeddedDevices) {
        super(identity, service, embeddedDevices);
    }

    @Override
    public DeviceType getDeviceType() {
        return new UDADeviceType("MY-DEVICE-TYPE-THREE", 3);
    }

    @Override
    public DeviceDetails getDeviceDetails() {
        return new DeviceDetails(
                "My Testdevice Third",
                new ManufacturerDetails("TELEAL", "http://www.teleal.org/"),
                new ModelDetails("MYMODEL", "TEST Device", "ONE", "http://www.teleal.org/another_embedded_model"),
                "000da201238d",
                "100000000003",
                "http://www.teleal.org/some_third_user_interface");

    }

    @Override
    public Icon[] getIcons() {
        return null;
    }

    @Override
    public DeviceService[] getDeviceServices() {
        return new DeviceService[]{
                new DeviceService(
                        getServiceThreeType(),
                        getServiceThreeId(),
                        getServiceThreeDescriptorURI(),
                        URI.create("service/upnp-org/MY-SERVICE-789/control"),
                        URI.create("service/upnp-org/MY-SERVICE-789/events")
                )

        };
    }

    public static UDN getEmbeddedTwoUDN() {
        return new UDN("MY-DEVICE-789");
    }

    public static ServiceId getServiceThreeId() {
        return new UDAServiceId("MY-SERVICE-789");
    }

    public static ServiceType getServiceThreeType() {
        return new UDAServiceType("MY-SERVICE-TYPE-THREE", 3);
    }

    public static URI getServiceThreeDescriptorURI() {
        return URI.create("service/upnp-org/MY-SERVICE-789/desc.xml");
    }

    public static URL getServiceThreeDescriptorURL() {
        return URIUtil.createAbsoluteURL(SampleDeviceRoot.getDeviceDescriptorURL(), getServiceThreeDescriptorURI());
    }

}